function [status,DES]=loop_gui(fdp,degreefd,Upper0,nz,Tname)

for i=1:1
%% Decleration
i;
%Tname=sprintf('W%d.xlsx', i);
[T,fp,N,M]=PLA2T(Tname);
%E=xlsread( Tname,'Sayfa1');
%[re,ce]=size(E);
%N=E(1,1);
%T=E([2:re],[1:N+1]);
%M=E(1,2);
%degreefd=E(1,3);
%Lower=E(1,4);
%Upper0=E(1,5);
%nz=E(1,6);

if Upper0==0
    Upper0=fp*fdp;
end

if Upper0>1
     Upper=min(Upper0,fp*fdp);
end



if Upper==4
   Upper=5;
end
Upper;

rdown=2;
cdown0=2;

optimalupper=1;
Dname=sprintf('D%d.xls', i);
    %% loop
rup=ceil(Upper0/cdown0);
b2=0;
for rd=rdown:rup
    rd;
    cdup=floor(Upper/rd);
    cdown=ceil((2/rd)*(degreefd+rd-1.5-((-1)^rd)/2));
    if cdown < cdown0
        cdown=cdown0;
    end
    if cdup >= cdown && rd*cdown < Upper
        optimalupper=0;
        if nz==0;
            subdesign=C2_posdesign(T,N,M,rd,i);
        elseif nz==1;
            subdesign=C2_posdesign_nozero(T,N,M,rd,i);
        end
        
        for cd=cdown:cdup
            cd;
        %% Design calculation
            if nz==0;
                [LAT,fin]=optimumV4(T,N,M,rd,cd,subdesign);
            elseif nz==1;
                [LAT,fin]=optimumV4_nozero(T,N,M,rd,cd,subdesign);
            end
        
            if fin==1
                LATd=LAT;
                Upper=rd*cd;
                b2=1;
                xlswrite(Dname, LATd, 'sheet')
                break
            end
        end    
        
        
    end
end


if optimalupper==1
    status=sprintf('Known Design is optimal (Altuns or yours)');
    DES=zeros(rdown,cdown0);
end


if b2==1
%% Design writing
LATd;

[rop,cop]=size(LATd);
status=sprintf('Optimal design is in above: %dx%d',rop,cop);

for ir=1:rop
    for ic=1:cop
        if abs(LATd(ir,ic))==N+1
            DES{ir,ic}='1';
        elseif LATd(ir,ic)==3
            if nz==0
                DES{ir,ic}='0';
            else
                DES{ir,ic}='1';
            end
        elseif LATd(ir,ic)>0
            DES{ir,ic}=sprintf('x%d',abs(LATd(ir,ic)));
        else
            DES{ir,ic}=sprintf('~x%d',abs(LATd(ir,ic)));
        end
    end
end

DES;
%xlswrite(Dname, LATd, 'sheet')
end
end

end
%%%%%%%%%%%%%%%%%%%%%%%%


function [T,fp,N,M]=PLA2T(filename)
fileID = fopen(filename,'r');
PLA_chr=fscanf(fileID,'%c');
fclose(fileID);

PLA_spc=find(isspace(PLA_chr));
N=PLA_spc(1)-1;
[r,c]=size(PLA_chr);
fp=(c+1)/(N+3);



PLA=zeros(fp,N);
k=0;
for i=1:fp
    for j=1:N
        k=k+1;      
        if PLA_chr(k)==PLA_chr(PLA_spc(1)+1)
            PLA(i,j)=1;
        elseif PLA_chr(k)==0
            PLA(i,j)=0;
        elseif PLA_chr(k)=='-'
            PLA(i,j)=100;
        end
        
        if j==N
            k=k+3;
        end
    end
end

%%[rz,cz]=find(~PLA)
M=N;

T=false((2^N),(N+1));
P=pos(N);
T=[P false(2^N,1)];

[rdc,cdc]=find(PLA>1);

dc_number=size(rdc);


temp=false(1,N);
for i=1:2^N
    prow=P(i,:);
    for k=1:fp
        T(i,N+1)=1;
        for j=1:N
            if PLA(k,j)==100
                temp(1,j)=1;
            else
                temp(1,j)=~xor(prow(j),PLA(k,j));
            end
            T(i,N+1)=T(i,N+1)*temp(1,j);
        end
        if T(i,N+1)==1
            break
        end
    end
end

end
%%%%%%%%%%%%%%%%%%%%%%%%%
function subdesigns=C2_posdesign(T,N,M,r,i)
tic
%% Pre-Arguments
ctwo=2;
%tooolargenumber=16777216;
%% Starting
fprintf('\n PosDesign Processing....%d %d\n',i,r);

l=N+M;
%% 

%% Declerations
Truth=false(2^N,N+2);
%LAT=zeros(r,ctwo);
%pos_design=(-M-1)*ones(1,r*ctwo); % hole number


%% Truth table with two outputs 
%First:lattices & Second:Function
P=T(:,[1:N]);
P=logical(P);
Truth=[P false(2^N,2)];
Truth=logical(Truth);

%% Truth(:,N+2)=T(:,N+1);
Truth(:,N+2)=T(:,N+1);
%% Truth table variable comparison
 subdesign=[];

for j = 0:(l+2)^(r*ctwo)-1 % permutation number
pos_design=dec2base(j,l+2,r*ctwo)-'0'-M-1;

  LAT=reshape(pos_design,r,ctwo);
  Truth0=LD2Tnew(LAT,Truth,N,M,r,ctwo,P);
  islarger=Truth0(:,N+2)-Truth0(:,N+1);
  
  if min(islarger)>-1;
    subdesign = [subdesign; pos_design];
  end
end
subdesigns=subdesign;

end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function subdesigns=C2_posdesign_nozero(T,N,M,r,i)
tic
%% Pre-Arguments
ctwo=2;
%tooolargenumber=16777216;
%% Starting
fprintf('\n PosDesign Processing....%d %d\n',i,r);

l=N+M;
%% 

%% Declerations
Truth=false(2^N,N+2);
%LAT=zeros(r,ctwo);
%pos_design=(-M)*ones(1,r*ctwo); % hole number
%subdesign=zeros(tooolargenumber,r*ctwo,12);

%% Truth table with two outputs 
%First:lattices & Second:Function
P=T(:,[1:N]);
P=logical(P);
Truth=[P false(2^N,2)];
Truth=logical(Truth);

%% Truth(:,N+2)=T(:,N+1);
Truth(:,N+2)=T(:,N+1);
%% Truth table variable comparison
 subdesign=[];
for j = 0:(l+1)^(r*ctwo)-1 % permutation number
pos_design=dec2base(j,l+1,r*ctwo)-'0'-M;

  LAT=reshape(pos_design,r,ctwo);
  Truth0=LD2Tnew_nozero(LAT,Truth,N,M,r,ctwo,P);
  islarger=Truth0(:,N+2)-Truth0(:,N+1);
  
  if min(islarger)>-1;
    subdesign = [subdesign; pos_design];
  end
end

subdesigns=subdesign;

toc
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [LAT,finish]=optimumV4(T,N,M,r,c,subdesign)
tic
%% Pre-Arguments

%% Starting
fprintf('\n Finding Design Processing....%d %d \n', r, c);
%subdesign=C2_posdesign(T,N,M,r,c,ctwo);
g=size(subdesign);
csub=g(2)/r;
g=g(1);
l=N+M;
diff=r*c-l;
%% 
if diff>=0

%% Declerations
Truth=false(2^N,N+2);
LAT=zeros(r,c);
pos_design=zeros(1,r*c); % hole number

%% Truth table with two outputs 
%First:lattices & Second:Function
P=T(:,[1:N]);
P=logical(P);
Truth=[P false(2^N,2)];
Truth=logical(Truth);

%% Truth(:,N+2)=T(:,N+1);
Truth(:,N+2)=T(:,N+1);  %%
%% Truth table variable comparison
finish=0;



x=c/csub; %%How many sub design

sdnumber=floor(x);
sdperm=ones(1,sdnumber);

sdperm(1)=sdperm(1)-1;

if x==1
    for j=1:g
        pos_design=subdesign(j,:);
        LAT=reshape(pos_design,r,c);
        Truth=LD2T(LAT,Truth,N,M,r,c,P);
        if isequal(Truth(:,N+1),Truth(:,N+2))==1;
            finish=1;
            break
        end
    end

    
elseif mod(x,2) == 0
for j = 1:g^sdnumber % permutation number
    sdperm(1)=sdperm(1)+1;
    for i = 1:sdnumber   %hole number
        if (sdperm(i) == g+1) %g
        	sdperm(i+1) = sdperm(i+1)+1;
        	sdperm(i) = 1; % first term
        end
        pos_design(1,[1+(i-1)*(r*csub):i*r*csub])=subdesign(sdperm(i),:);        
    end
    
        %use design
%         for k=1:r*c
%         LAT(k)=pos_design(k);
%         end
        
        LAT=reshape(pos_design,r,c);
        Truth=LD2T(LAT,Truth,N,M,r,c,P);
        if isequal(Truth(:,N+1),Truth(:,N+2))==1;
            finish=1;
            break
        end
end

else
    

    oddcol=(-M-1)*ones(1,r);
    
    for w=0:(l+2)^r-1
        oddcol=dec2base(w,l+2,r)-'0'-M-1
        
   pos_design(1,[sdnumber*r*csub+1:r*c])=oddcol;
    sdperm=ones(1,sdnumber);
    sdperm(1)=sdperm(1)-1;
for j = 1:g^sdnumber % permutation number
    sdperm(1)=sdperm(1)+1;
    for i = 1:sdnumber   %hole number
        if (sdperm(i) == g+1) %g
        	sdperm(i+1) = sdperm(i+1)+1;
        	sdperm(i) = 1; % first term
        end
        pos_design(1,[1+(i-1)*(r*csub):i*r*csub])=subdesign(sdperm(i),:);        
    end
        %use design
%         for k=1:r*c
%         LAT(k)=pos_design(k);
%         end
        
        LAT=reshape(pos_design,r,c);
        Truth=LD2T(LAT,Truth,N,M,r,c,P);
        if isequal(Truth(:,N+1),Truth(:,N+2))==1;
            finish=1;
            break
        end
end
    if finish==1
        break
    end
    end
    
end




%%
else
    printf('size of lattice is too small')
    finish=0;
end
toc

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [LAT,finish]=optimumV4_nozero(T,N,M,r,c,subdesign)
tic
%% Pre-Arguments

%% Starting
fprintf('\n Finding Design Processing....%d %d \n', r, c);
%subdesign=C2_posdesign_nozero(T,N,M,r,c,ctwo);
g=size(subdesign);
csub=g(2)/r;
g=g(1);
l=N+M;
diff=r*c-l;
%% 
if diff>=0

%% Declerations
Truth=false(2^N,N+2);
LAT=zeros(r,c);
pos_design=zeros*ones(1,r*c); % hole number

%% Truth table with two outputs 
%First:lattices & Second:Function
P=T(:,[1:N]);
P=logical(P);
Truth=[P false(2^N,2)];
Truth=logical(Truth);

%% Truth(:,N+2)=T(:,N+1);
Truth(:,N+2)=T(:,N+1);
%% Truth table variable comparison
finish=0;



x=c/csub; %%How many sub design

sdnumber=floor(x);
sdperm=ones(1,sdnumber);

sdperm(1)=sdperm(1)-1;
if x==1
    for j=1:g
        pos_design=subdesign(j,:);
        LAT=reshape(pos_design,r,c);
        Truth=LD2T_nozero(LAT,Truth,N,M,r,c,P);
        if isequal(Truth(:,N+1),Truth(:,N+2))==1;
            finish=1;
            break
        end
    end

    
elseif mod(x,2) == 0

for j = 1:g^sdnumber % permutation number
    sdperm(1)=sdperm(1)+1;
    for i = 1:sdnumber   %hole number
        if (sdperm(i) == g+1) %g
        	sdperm(i+1) = sdperm(i+1)+1;
        	sdperm(i) = 1; % first term
        end
        pos_design(1,[1+(i-1)*(r*csub):i*r*csub])=subdesign(sdperm(i),:);        
    end
        %use design
%         for k=1:r*c
%         LAT(k)=pos_design(k);
%         end
        LAT=reshape(pos_design,r,c);
        Truth=LD2T_nozero(LAT,Truth,N,M,r,c,P);
        if isequal(Truth(:,N+1),Truth(:,N+2))==1;
            finish=1;
            break
        end
end

else
    oddcol=(-M)*ones(1,r);
    oddcol(1)=oddcol(1)-1;
    for w=0:(l+1)^r-1
        oddcol=dec2base(w,l+1,r)-'0'-M;

   pos_design(1,[sdnumber*r*csub+1:r*c])=oddcol;
   
   sdperm=ones(1,sdnumber);
    sdperm(1)=sdperm(1)-1;     
for j = 1:g^sdnumber % permutation number
    sdperm(1)=sdperm(1)+1;
    for i = 1:sdnumber   %hole number
        if (sdperm(i) == g+1) %g
        	sdperm(i+1) = sdperm(i+1)+1;
        	sdperm(i) = 1; % first term
        end
        pos_design(1,[1+(i-1)*(r*csub):i*r*csub])=subdesign(sdperm(i),:);        
    end
        %use design
%         for k=1:r*c
%         LAT(k)=pos_design(k);
%         end
        
        LAT=reshape(pos_design,r,c);
        Truth=LD2T_nozero(LAT,Truth,N,M,r,c,P);
        if isequal(Truth(:,N+1),Truth(:,N+2))==1;
            finish=1;
            break
        end
end    
    if finish==1
        break
    end
    end
    
end

%%
else
    printf('size of lattice is too small')
    finish=0;
end
toc
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function T=pos(N)
L=2^N;
T =false(L,N);
for k = 0:(L-1) 
    x = de2bi(k,N,'left-msb');
    x=logical(x);
    T(k+1,:)=x;
end 
end

%%%%%%%%%%


function Truth=LD2Tnew(D,T,N,M,r,c,P)
X=false(1,N);
LAT=false(r,c);

for i=1:r
    for j=1:c
        if D(i,j)==(-M-1);
            D(i,j)=100;
        end
        if D(i,j)<0
            D(i,j)=abs(D(i,j)-N);
        end           
    end
end



%% Loop
for n=1:2^N

X=P(n,:);
X=logical(X);

%% Lattice Design

Xc=[X not(X)];
for i=1:r
    for j=1:c
        if D(i,j)==0
            LAT(i,j)=0;
        elseif D(i,j)==100; %The value which stands for 1
            LAT(i,j)=1;
        else
            LAT(i,j)=Xc(D(i,j));
        end
    end
end

%% Value of Lattice
T(n,N+1)=evallattice(LAT);
end
Truth=T;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Truth=LD2Tnew_nozero(D,T,N,M,r,c,P)
X=false(1,N);
LAT=false(r,c);

for i=1:r
    for j=1:c
        if D(i,j)<0
            D(i,j)=abs(D(i,j)-N);
        end           
    end
end



%% Loop
for n=1:2^N

X=P(n,:);
X=logical(X);

%% Lattice Design

Xc=[X not(X)];
for i=1:r
    for j=1:c
        if D(i,j)==0 %The value which stands for 1
            LAT(i,j)=1;
        else
            LAT(i,j)=Xc(D(i,j));
        end
    end
end

%% Value of Lattice
T(n,N+1)=evallattice(LAT);
end
Truth=T;

end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Truth=LD2T(D,T,N,M,r,c,P)
X=false(1,N);
LAT=false(r,c);

for i=1:r
    for j=1:c
        if D(i,j)==(-M-1);
            D(i,j)=100;
        end
        if D(i,j)<0
            D(i,j)=abs(D(i,j)-N);
        end           
    end
end



%% Loop
for n=1:2^N

X=P(n,:);
X=logical(X);

%% Lattice Design

Xc=[X not(X)];
for i=1:r
    for j=1:c
        if D(i,j)==0
            LAT(i,j)=0;
        elseif D(i,j)==100; %The value which stands for 1
            LAT(i,j)=1;
        else
            LAT(i,j)=Xc(D(i,j));
        end
    end
end

%% Value of Lattice
T(n,N+1)=evallattice(LAT);
if isequal(T(n,N+1),T(n,N+2))==0;
	break
end

end
Truth=T;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5

function Truth=LD2T_nozero(D,T,N,M,r,c,P)
X=false(1,N);
LAT=false(r,c);

for i=1:r
    for j=1:c
        if D(i,j)<0
            D(i,j)=abs(D(i,j)-N);
        end           
    end
end



%% Loop
for n=1:2^N

X=P(n,:);
X=logical(X);

%% Lattice Design

Xc=[X not(X)];
for i=1:r
    for j=1:c
        if D(i,j)==0 %The value which stands for 1
            LAT(i,j)=1;
        else
            LAT(i,j)=Xc(D(i,j));
        end
    end
end

%% Value of Lattice
T(n,N+1)=evallattice(LAT);

if isequal(T(n,N+1),T(n,N+2))==0;
	break
end

end
Truth=T;

end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function f=evallattice(PL)
[r,c]=size(PL);
B=logical(PL);
B =bwlabel(PL,4);
f=0;
if length(intersect(B(1,:),B(r,:)))>1
f=1;
elseif intersect(B(1,:),B(r,:))~=0;
f=1;
end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



