#!/usr/bin/python
import sys

inputs = int(sys.argv[-3])
rows = int(sys.argv[-2])
cols = int(sys.argv[-1])

vals = { idx : None for idx in xrange(rows*cols) }
for line in sys.stdin.readlines():
  if line.startswith('v') or line.startswith('V'):
    elts = map(int, line.strip().split()[1:])
    if elts[-1] == 0:
      elts = elts[:-1]

    for vi in elts:
      if vi > 0:
        ## (2*in + 2) vals
        ## 2*in partial sum lits
        vv = (vi-2) % (4*inputs + 2)
        if vv < 2*inputs + 2:
          idx = (vi-2)/(4*inputs+2)
          if idx not in vals:
            continue
          assert vals[idx] is None
#        print vv

          sgn = 1 - (2*(vv%2))
          val = vv/2
          if val == 0:
            if sgn == 1:
              vals[idx] = "F"
            else:
              vals[idx] = "T"
          else:
            vals[idx] = str(sgn*val)

#for idx in vals:
#  print idx, ":", vals[idx]

table = [ [ vals[r*cols + c] for c in xrange(cols) ] for r in xrange(rows) ]
ws = [ max([len(table[r][c]) for r in xrange(rows)]) for c in xrange(cols) ]

for row in table:
  print " | ".join([ " "*(ws[c] - len(row[c])) + row[c] for c in xrange(len(row))])
