class Lit:
  def __init__(self, v):
    assert v != 0
    self.v = v

  def __invert__(self):
    return Lit(-1*self.v)
  def __eq__(self, other): 
    return self.v == other.v
  def __repr__(self):
    return repr(self.v)

  def sign(self):
    if self.v < 0:
      return -1
    else:
      return 1

  def var(self):
    return abs(self.v)

class FDVar:
  def __init__(self, vs, ovars):
    self.vs = vs
    self.ords = ovars
